Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.drools.runtime
Interface StatelessKnowledgeSession

All Superinterfaces:
  CommandExecutor, KnowledgeRuntimeEventManager, ProcessEventManager, StatelessProcessSession, StatelessRuleSession, WorkingMemoryEventManager

    public interface StatelessKnowledgeSession

extends StatelessRuleSession, StatelessProcessSession, CommandExecutor, KnowledgeRuntimeEventManager

StatelessKnowledgeSession provides a convenience API, wrapping StatefulKnowledgeSession. It avoids the need to call dispose(). Stateless sessions do not support iterative invocations, the act of calling execute(...) is a single shot method that will internally instantiate a StatefulKnowledgeSession, add all the user data and execute user commands, call fireAllRules, and then call dispose(). While the main way to work with this class is via the BatchExecution Command as supported by the CommandExecutor interface, two convenience methods are provided for when simple object insertion is all that's required.

Simple example showing a stateless session executing for a given collection of java objects using the convenience api. It will iterate the collection inserting each element in turn

     KnowledgeBuilder kbuilder = KnowledgeBuilderFactory.newKnowledgeBuilder();
     kbuilder.add( ResourceFactory.newFileSystemResource( fileName ), ResourceType.DRL );
     assertFalse( kbuilder.hasErrors() );
     if (kbuilder.hasErrors() ) {
         System.out.println( kbuilder.getErrors() );
     }
     KnowledgeBase kbase = KnowledgeBaseFactory.newKnowledgeBase();
     kbase.addKnowledgePackages( kbuilder.getKnowledgePackages() );

     StatelessKnowledgeSession ksession = kbase.newStatelessKnowledgeSession();
     ksession.execute( collection );

If this was done as a single Command it would be as follows:

     ksession.execute( CommandFactory.newInsertElements( collection ) );

Note if you wanted to insert the collection itself, and not the iterate and insert the elements, then CommandFactory.newInsert( collection ) would do the job.

The CommandFactory details the supported commands, all of which can be marshalled using XStream and the BatchExecutionHelper. BatchExecutionHelper provides details on the XML format as well as how to use Drools Pipeline to automate the marshalling of BatchExecution and ExecutionResults.

StatelessKnowledgeSessions support globals, scoped in a number of ways. I'll cover the non-command way first, as commands are scoped to a specific execution call. Globals can be resolved in three ways. The StatelessKnowledgeSession supports getGlobals(), which returns a Globals instance. These globals are shared for ALL execution calls, so be especially careful of mutable globals in these cases - as often execution calls can be executing simultaneously in different threads. Globals also supports a delegate, which adds a second way of resolving globals. Calling of setGlobal(String, Object) will actually be set on an internal Collection, identifiers in this internal Collection will have priority over supplied delegate, if one is added. If an identifier cannot be found in the internal Collection, it will then check the delegate Globals, if one has been set.

Code snippet for setting a session scoped global:

     StatelessKnowledgeSession ksession = kbase.newStatelessKnowledgeSession();
     ksession.setGlobal( "hbnSession", hibernateSession ); // sets a global hibernate session, that can be used for DB interactions in the rules.
     ksession.execute( collection ); // this will now execute and will be able to resolve the "hbnSession" identifier.

The third way is execution scopped globals using the CommandExecutor and SetGlobal Commands:

     List cmds = new ArrayList();
     cmds.add( CommandFactory.newSetGlobal( "list1", new ArrayList() ) );
     cmds.add( CommandFactory.newInsert( new Person( "jon", 102 ) ) );

     ksession.execute( CommandFactory.newBatchExecution( cmds ) );

The CommandExecutor interface also supports the ability to export data via "out" parameters. Inserted facts, globals and query results can all be returned.

     List cmds = new ArrayList();
     cmds.add( CommandFactory.newSetGlobal( "list1", new ArrayList(), true ) );
     cmds.add( CommandFactory.newInsert( new Person( "jon", 102 ), "person" ) );
     cmds.add( CommandFactory.newQuery( "Get People" "getPeople" );

     ExecutionResults results = ksession.execute( CommandFactory.newBatchExecution( cmds ) );
     results.getValue( "list1" ); // returns the ArrayList
     results.getValue( "person" ); // returns the inserted fact Person
     results.getValue( "Get People" );// returns the query as a QueryResults instance.

See Also:
  `CommandExecutor`, `org.drools.runtime.command.CommandFactory`, `org.drools.runtime.command.BatchExecution`, `org.drools.runtime.ExecutionResults.BatchExecutionResults`, `org.drools.runtime.help.BatchExecutionHelp`, `org.drools.runtime.pipeline.PipelineFactory`, `Globals`

Method Summary
`Globals` | `getGlobals()` Return the Globals store
`void` | `setGlobal(String identifer, Object value)` Sets a global value on the globals store

Methods inherited from interface org.drools.runtime.rule.StatelessRuleSession
`execute, execute`

Methods inherited from interface org.drools.runtime.CommandExecutor
`execute`

Methods inherited from interface org.drools.event.rule.WorkingMemoryEventManager
`addEventListener, addEventListener, getAgendaEventListeners, getWorkingMemoryEventListeners, removeEventListener, removeEventListener`

Methods inherited from interface org.drools.event.process.ProcessEventManager
`addEventListener, getProcessEventListeners, removeEventListener`

Method Detail

### getGlobals

    Globals getGlobals()

  Return the Globals store

### setGlobal

    void setGlobal(String identifer,
                   Object value)

  Sets a global value on the globals store

  Parameters:
    `identifer` - the global identifier
    `value` - the value assigned to the global identifier

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2001-2014 JBoss by Red Hat. All Rights Reserved.